-- Install handler for PL/pgSQL on the PostgreSQL server
-- Copyright (c) 2000 The FreeMoney Project
-- This work is released under the GPL
-- $Id: create_function_plpgsql.sql,v 1.4 2001/01/23 21:19:36 kaare Exp $

DROP FUNCTION plpgsql_call_handler ();
CREATE FUNCTION plpgsql_call_handler () RETURNS OPAQUE AS
  '/usr/local/pgsql/lib/plpgsql.so' LANGUAGE 'C';

COMMENT ON FUNCTION plpgsql_call_handler() IS 'Engine for executing PL/pgSQL function.
This function should be installed prior to install any other PL/pgSQL functions.
The handler is installed in the database and all FreeMoney databases need to have the handler installed.';

DROP PROCEDURAL LANGUAGE 'PLpgSQL';
CREATE TRUSTED PROCEDURAL LANGUAGE 'PLpgSQL'
  HANDLER plpgsql_call_handler
  LANCOMPILER 'PL/pgSQL';

-- EOF
