-- Functions for the product module
-- Copyright (c) 2001 The FreeMoney Project
-- This work is released under the GPL
-- $Id: create_function_product.sql,v 1.2 2001/03/31 17:29:37 kaare Exp $

-- Functions
DROP FUNCTION pd_newprice();

CREATE FUNCTION pd_newprice() RETURNS OPAQUE AS ' BEGIN
 if new.validfrom > new.validto then
  RAISE EXCEPTION ''validfrom cannot be later than validto'';
 end if;
 if new.validfrom > old.validto then
  INSERT INTO pd_artprice (art_id , type, validfrom, validto, price, updated)
   VALUES (new.art_id , new.type, new.validfrom, new.validto, new.price, new.updated);
  RETURN null;
 end if;
 if new.validfrom = old.validfrom then
  new.validfrom = timenow();
 end if;
 if new.updated = old.updated then
  new.updated = timenow();
 end if;
 new.validto = old.validto;
 old.validto = new.validfrom;
 INSERT INTO pd_artprice (art_id , type, validfrom, validto, price, updated)
  VALUES (new.art_id , new.type, new.validfrom, new.validto, new.price, new.updated);
 RETURN old;
END; '
language 'plpgsql';

-- Triggers
DROP TRIGGER pd_newprice ON pd_artprice;

CREATE TRIGGER pd_newprice BEFORE UPDATE ON pd_artprice
 FOR EACH ROW EXECUTE PROCEDURE pd_newprice();
